/* ReadFile.js

   Date       | Change/Update/Fix etc.
   -----------|----------------------------------------------------------
   11/14/2002 - When we search for an anchor and then load a new DB
                that has no anchors, the anchor search is still triggered
                since the old value (to search for) is still in the var.
                To get around this I added a new var BADAnchor to tell
                us when it would be bad to search for anchors.
                I tried changing: document.Lookup.MyAnchors.value but
                that didn't work. I guess because it no longer exists!???
                -----
              - Added the loading filename to the display on the screen.  
   -----------|----------------------------------------------------------                
*/
   var GotAnchor = 0; 
   var AutoAnchors = new Array(); // To hold the names of all the AutoAnchors
   var ThisAnchor = "-----";
   var Page = "";
   var Pointer=0;
   var MyDoc = "";
   var MyKey = "";
   var Title = document.title;
   var srch = "head>";
   var TmpStng = "";
   var count = 0; // the waiting counter. pktst 3/27/02
   var LastLength = 0; // last length of innerHTML read
   var SetUpChk = 0;
   var link = links[0];
   var BadAnchor = 0; // if set to 1 then we have No Anchors!

   // --------------------------------------------------------
   // Come here to open the default or given file for loading
   // --------------------------------------------------------
   function Init() {
     var name = "DataPage";
     PfindInit();
     
     if(Bad) {
        document.location = links[0];
     }

     if(!document.documentElement.innerHTML) {
        alert("Sorry, this browser can NOT download the data file.");
        return;
     }
     if(document.FileName.file.value != "") {
        link = document.FileName.file.value;
     }

     TmpStng = link.toLowerCase();
     if(TmpStng.indexOf("htm") == -1) {
        srch = "html>";
     }

     MyKey = window.open(link, name);
     MyKey.blur();
     Msg("Loading file: - "+link+" - Data, please wait."); // Display this!

     count = 0;      // Clear the time counter
     LastLength = 0; // clear this so we can test it for THIS file.
     Pointer = window.setTimeout("ContinueRead();", 100); // 0.1 sec
     document.Lookup.PfindStuf.focus();
   }


   // ----------------------------------------------------
   // Come here to get the inner HTML after the delay
   // ----------------------------------------------------
   function ContinueRead() {
     clearTimeout(Pointer); // 0.5 sec

     if(MyKey.document.documentElement == null) {
        count += 0.1; // add 0.1 second to the time counter
        var Scount = OnePlace(count);
        Pointer = window.setTimeout("ContinueRead();", 100); // 0.1 sec
        window.status="Still waiting..."+Scount+" sec.";
        return;
     }
     while (MyKey.document.documentElement.innerHTML.length != LastLength) {
        count += 0.5; // add 1/2 second to the time counter
        var Scount = OnePlace(count);
        LastLength = MyKey.document.documentElement.innerHTML.length;
        window.status="Still working..."+Scount+" sec. - "+LastLength+" Bytes read.";
        Pointer = window.setTimeout("ContinueRead();", 500); // 0.5 sec
        return;
     }
     // alert("Are we done?"); // Now wait till the sub-window MyKey is done loading!
     // If we wait, then clear this alert all data is read in AOK!

     // ------------------------------------------------------------
     // On the server we have problems with this line, no object
     // I can only assume that since the page takes too long to
     // load, it doesn't yet have the innerHTML
     // ------------------------------------------------------------
     Page = MyKey.document.documentElement.innerHTML;
     // ------------------------------------------------------------
     //alert("Page = "+Page); // pktxt

     All = Page; // Needed by the Pfind.js functions.

     // -----------------------------------------------------------
     // One last check, did we really get the bottom of this file?
     // For some reason we can NOT check for </pre> or </PRE> if
     // the file is on the WWW. It ALWAYS puts </PRE></BODY> at
     // the end of the file! So, we MUST put something at the end
     // that we can search for. I put: "<end></end>"
     // Also, the web does NOT show the </html> EVER!
     //
     // The &lt;end&gt; etc are needed for NetScape 6.0 to end
     // its search of the data. 03/28/2002 pk
     // -----------------------------------------------------------
     var done = 0;
     if (All.indexOf("***end***end***", LastLength-100) != -1 ) {
         done = 1;
         //alert(All.substring(LastLength-100, LastLength));
     }
     if(!done) {

        count += 0.1; // add 1/2 second to the time counter
        var Scount = OnePlace(count); // Only one decimal place.

        window.status="Still working * "+Scount+" sec. - "+LastLength+" Bytes read.";
        //var Stng = All.substring(LastLength-100, LastLength);
        //alert("Are we there yet?\n\n"+Stng);

        Pointer = window.setTimeout("ContinueRead();", 100); // 0.1 sec
        return;
     }
     else {
        //var Stng = All.substring(LastLength-100, LastLength);
        //alert("Yup, we're at the bottom of the file!\n\n"+Stng);
     }
     // -----------------------------------------------------------

     MyKey.close();

     // Need this delay to actually read the data.
     Pointer = window.setTimeout("GetIt();", 500); // 0.5 sec
   }


   // ----------------------------------------------------
   // Come here to load the data into an Array of lines
   // ----------------------------------------------------
   function GetIt() {

     if(All) {
       var Lines = Page.split("\n");
       MyDoc="<b>The data from ["+link+"] is: </b><br><hr>";
       var first = 0;
       var last = 0;
       var done = 0;

       // -------------------------------------------------------
       // Find the actual data lines, data starts with "*" and
       // ends with "*" as the first chars on the lines
       // -------------------------------------------------------
       for(i=0; i<Lines.length && !done; ++i) {
         TmpStng = Lines[i].toLowerCase();
         if(TmpStng.indexOf(srch) != -1 && !first) {
            first = i+1;
         }
         else if(TmpStng.indexOf(srch) != -1 && first) {
            last = i-1;
            done = 1;
         }
         else {
            last = i-1;
         }
       }
       ++last; // Need to get the last line as well.
       // -------------------------------------------------------

       // -----------------------------------------------------------
       // Build up the inner HTML with the loaded data & display it.
       // -----------------------------------------------------------
       MyDoc += "<pre>\n"; // Just get the data as it is (as much as we can.)

       var count = 0;
       for(i=first; i<last; ++i) { // Display the data lines pk05
         // -----------------------------------------------------------
         // This section is needed so that the data will display
         // correctly in NetScape. NS replaces all < > with &lt; &gt;
         // and these MUST be replaced with < > if we are to get the
         // HTML saved in the txt file. IE doesn't do this!
         // -----------------------------------------------------------
         if(Lines[i].indexOf("&lt;") != -1 || Lines[i].indexOf("&gt;") != -1) {
            NSFlg = 1; // Yup, might be Netscape!
            
            var old = Lines[i];
            while(Lines[i].indexOf("&lt;") != -1) {
               var pntr = Lines[i].indexOf("&lt;");
               var stn = Lines[i].substring(0, pntr);
               stn += "<";
               stn += Lines[i].substring(pntr+4, Lines[i].length);
               Lines[i] = stn;
            }
            while(Lines[i].indexOf("&gt;") != -1) {
               var pntr = Lines[i].indexOf("&gt;");
               var stn = Lines[i].substring(0, pntr);
               stn += ">";
               stn += Lines[i].substring(pntr+4, Lines[i].length);
               Lines[i] = stn;
            }
         }
         // -----------------------------------------------------------

         // -----------------------------------------------------------
         // Check for Anchors in this file, get the names of each
         // -----------------------------------------------------------
         if(Lines[i].indexOf("<a name=") != -1) {
            var pntr = Lines[i].indexOf("<a name=");
            var chop = 2;

            var tmp = Lines[i].substring(pntr+9, Lines[i].length-chop);

            // --------------------------------------------------------------
            // This check is needed because NS doesn't count CR-LF as
            // part of the length of the string when the string comes
            // from a txt file. Yet if I search on \n or \r they are found!
            // --------------------------------------------------------------
            if(tmp.indexOf('"') != -1 || tmp.indexOf("'") != -1)
               tmp = tmp.substring(0, tmp.length-1); // remove last char ' or "
            // --------------------------------------------------------------

            AutoAnchors[count] = tmp;
            ++count;
         }
         GotAnchor = count;
         // -----------------------------------------------------------

         MyDoc += Lines[i]; // Just get the data pk05
         if(!NSFlg) // for IE type browsers
            MyDoc += "<br>"; // Needed in IE

         window.status="Line "+i+" loaded.";  // Lines Loaded Status Message
       }

       MyDoc += "</pre>\n<hr><br>done.<br>";
       // -----------------------------------------------------------
     }

     id = document.getElementById("data");
     id.innerHTML = MyDoc;

     TmpStng = "***** Got the Page! ***** "+Title+" ***** Got the Page! ***** ";
     window.status = TmpStng;

     SetUp(); // Now set up the select list of allowed files

     // -----------------------------------------------------------
     // Check for Anchors & if we have them, make a select box!
     // -----------------------------------------------------------
     if(!GotAnchor) { // Remove anchor searching if no AutoAnchors found
        var obj2 = document.getElementById("AnchorsHere");

        obj2.innerHTML="<center><b>Select a search </b>(removed)</center>";
        
        BadAnchor = 1; // No anchors, so searching for them is BAD!
     }
     else {
        var obj2 = document.getElementById("AnchorsHere");
        var Stn = "<b>Select "+AnchorName+"</b> ";
        
        Stn += "<select name='MyAnchors' onChange='FindAnchor();'>\n";
        Stn += '<option value="-----">-----</option>\n';

        AutoAnchors = AutoAnchors.sort();

        for (var j=0; j<AutoAnchors.length; ++j) {
           Stn += '<option value="'+AutoAnchors[j]+'">'+AutoAnchors[j]+'</option>\n';
        }
        Stn += "</select> to search for\n";
        obj2.innerHTML = Stn;

        BadAnchor = 0; // We have anchors, so searching for them is OK!
     }
     // -----------------------------------------------------------

   }



   // ********************************************************************
   // ********************************************************************
   //                               Utilities
   // ********************************************************************
   // ********************************************************************


   // -------------------------------------------------------------------
   // The needed look-up sections for the Pfind.js search routines.
   // -------------------------------------------------------------------
   function FindMe() {
     //var GoTo = "#"+document.Lookup.Anchor.value;
     var GoTo = "#"+ThisAnchor;
     GoTo = GoTo.toUpperCase(); // Make sure we can match Anchor names

     if (GoTo != "#-----" && !BadAnchor) { // Don't search if we don't have!
       document.location = GoTo; // Looking for an Anchor
     }
     else if (document.Lookup.Pfind[0].checked) {
       Pfind("R"); // Return complete records containing matched lines
     }
     else if (document.Lookup.Pfind[1].checked) {
       Pfind("A"); // Return Address lines for record containing matched line
     }
     else if (document.Lookup.Pfind[2].checked) {
       Pfind("L"); // Just return the lines that match.
     }
     return false;
   }


   // -------------------------------------------------------------------
   // Add your status line message for roll-over an image here
   // -------------------------------------------------------------------
   function Click() {
     window.status="Click here to view larger image."
   }



   // -------------------------------------------------------------------
   // Add your Default status line message here
   // -------------------------------------------------------------------
   function Base() {
     window.status = Title; // Same as Page title now
   }
   // -------------------------------------------------------------------

   // -------------------------------------------------------------------
   // Return a string of a decimal number of only one decimal place
   //
   // inputs:   the decimal number
   // outputs:  none
   // actions:  none
   // returns:  the string of the number with one decimal place
   // -------------------------------------------------------------------
   function OnePlace(num) {
      var Scount= ""+num;
      var pnt = Scount.indexOf(".");
      if(Scount.length > pnt + 1 && pnt > -1) {
         Scount = Scount.substring(0,pnt+2);
         //alert("In Here 001\n\nlength: "+Scount.length+"\npnt: "+pnt);
      }
      else if (pnt == Scount.length-1) {
         Scount += "0";
      }
      else {
         Scount += ".0";
      }

      //alert("returning: "+Scount);
      return Scount;
   }
   // -------------------------------------------------------------------


   // -------------------------------------------------------------------
   // SetUp sets up the select box of valid file names that can be read
   // It uses the values stored in the links Array.
   // -------------------------------------------------------------------
   function SetUp() {
      var Stng = "<select NAME='ListBox' onChange='LoadMe();'>\n";
      for(var j=0; j<links.length; ++j) {
         Stng += '<option value="'+links[j]+'"';
         if(j == SetUpChk)
            Stng += " selected ";
         Stng += '>'+links[j]+'</option>\n';
      }
      Stng += "</select> - Select the file to load and search.\n\n";

      var obj = document.getElementById("SelectBox");
      obj.innerHTML = Stng;
   }
   // -------------------------------------------------------------------

   // -------------------------------------------------------------------
   // LoadMe - Loads the selectBox file name and loads that file.
   // -------------------------------------------------------------------
   function LoadMe() {
      //alert(document.Lookup.ListBox.value);

      document.FileName.file.value = links[0];

      if(document.Lookup.ListBox.value) {
         document.FileName.file.value = document.Lookup.ListBox.value;
         var done = 0;
         for (var j=0; j<links.length && !done; ++j) {
            if (links[j] == document.FileName.file.value) {
              SetUpChk = j;
              done = 1;
            }
         }
      }

      Init();
   }
   // -------------------------------------------------------------------


   // -------------------------------------------------------------------
   // FindAnchor - Loads the MyAnchors selectBox file name and loads that
   //              file.
   // -------------------------------------------------------------------
   function FindAnchor() {

      // ----------------------------------------------------------
      // This should be: Object/HTML form element, but for some reason
      // even tho' the select list is there, the object is not in NS!?
      // Problem was in the caret.htm file at the title lines! fixed!
      // -------------------------------------------------------------
      ThisAnchor = document.Lookup.MyAnchors.value;
      if(ThisAnchor != "-----") {
         FindMe();
      }
   }
   // -------------------------------------------------------------------

   // -------------------------------------------------------------------
   // Display a message in the status line & on the screen
   //
   // inputs:   The message string
   // outputs:  Message to the status line & the screen
   // actions:  none
   // returns:  none
   // -------------------------------------------------------------------
   function Msg(Txt) {
      window.status = Txt;

      var obj = document.getElementById("SelectBox");
      obj.innerHTML = "<font color='red'><h2>"+Txt+"</h2></font>";
   }
   // -------------------------------------------------------------------


   // -------------------------------------------------------------------
   // -------------------------------------------------------------------
   function whatFile() {
      //window.location= 'file:///' + document.Lookup.cmuds.value;
      window.open('file:///' + document.Lookup.cmuds.value, "Text");
   }
   // -------------------------------------------------------------------
